﻿Option Strict On
Imports Microsoft.Devices
Imports System.IO
Imports System.IO.IsolatedStorage
Imports System.Xml.Linq
Imports Microsoft.Phone
Imports System.Windows.Media.Imaging
Imports MultiTouch.Behaviors.Silverlight4
Imports System.Windows.Interactivity
Partial Public Class CatchPhotoPage
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    Dim myPhotoCamera As PhotoCamera
    Dim imageFileName As String
    Dim recordDate As String
    Dim bufferValue As Integer = 5119
    Dim behavior As New MultiTouchBehavior
    Dim myImage As New Image

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)

        If e.NavigationMode = NavigationMode.Back Then
            myImage.Visibility = Windows.Visibility.Collapsed
        Else
            myImage.Visibility = Windows.Visibility.Visible
        End If

        Dim kanjiName As String = NavigationContext.QueryString("imagename")

        With myImage
            .Width = 400
            .Height = 100
            .Stretch = Stretch.Uniform
            .Source = New BitmapImage(New Uri(kanjiName, UriKind.Relative))
        End With

        'この記述がないとBackキーで戻った時Element is already the child of another element.のエラーがでるので注意
        If InkPresenter1.Children.Contains(myImage) = False Then
            InkPresenter1.Children.Add(myImage)
        End If
        With behavior
            .CenterX = 200
            .CenterY = 50
            .IsInertiaEnabled = False
            .IsTranslateEnabled = True
            .IsScaleEnabled = True
            .MinimumScale = 50
            .MaximumScale = 360
            .IsPivotEnabled = False
            .AreFingersVisible = True
            .Attach(myImage)
        End With

        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim filePath As String = Path.Combine("MultiTouchBehavior", "ImageList.xml")
        If storage.FileExists(filePath) = True Then
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = True
        Else
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = False
        End If


        myPhotoCamera = New PhotoCamera
        myVideoBrush.SetSource(myPhotoCamera)

        AddHandler myPhotoCamera.Initialized, Sub(cameraSender As Object, cameraArgs As CameraOperationCompletedEventArgs)
                                                  Try
                                                      If cameraArgs.Succeeded = False Then
                                                          Exit Sub
                                                      Else
                                                          Dim myResolution As IEnumerable(Of Size) = myPhotoCamera.AvailableResolutions
                                                          myPhotoCamera.Resolution = myResolution.First
                                                          myPhotoCamera.FlashMode = FlashMode.Auto
                                                      End If
                                                  Catch
                                                      Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                                                                    MessageBox.Show("カメラが開始するまでしばらくお待ちください。")
                                                                                                End Sub)

                                                  End Try

                                              End Sub
        AddHandler myPhotoCamera.CaptureImageAvailable, AddressOf myPhotoCamera_CaptureImageAvailable
        MyBase.OnNavigatedTo(e)
    End Sub


    Private Sub myPhotoCamera_CaptureImageAvailable(sender As Object, e As ContentReadyEventArgs)
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication

        Dim filePath As String = Path.Combine("MultiTouchBehavior", imageFileName)
        Dim xmlFilePath As String = Path.Combine("MultiTouchBehavior", "ImageList.xml")

        Using myStream As IsolatedStorageFileStream = storage.CreateFile(filePath)
            Dim myBuffer(bufferValue) As Byte
            Dim myByteRead As Integer = -1
            Do
                myByteRead = e.ImageStream.Read(myBuffer, 0, myBuffer.Length)
                myStream.Write(myBuffer, 0, myByteRead)
            Loop While (myByteRead > 0)
            e.ImageStream.Close()
        End Using

        Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                      Dim imageStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
                                                      Using stream As IsolatedStorageFileStream = imageStorage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
                                                          Dim imageSource As WriteableBitmap = PictureDecoder.DecodeJpeg(stream)
                                                          backgroundImage.Source = imageSource
                                                      End Using

                                                      Dim myWriteableBitmap As WriteableBitmap
                                                      myWriteableBitmap = New WriteableBitmap(InkPresenter1, Nothing)
                                                      If imageStorage.FileExists(Path.Combine("MultiTouchBehavior", imageFileName)) = True Then
                                                          imageStorage.DeleteFile(Path.Combine("MultiTouchBehavior", imageFileName))
                                                      End If
                                                      Using Stream As IsolatedStorageFileStream = storage.CreateFile(Path.Combine("MultiTouchBehavior", imageFileName))
                                                          System.Windows.Media.Imaging.Extensions.SaveJpeg(myWriteableBitmap, Stream, 480, 640, 0, 85)
                                                      End Using
                                                  End Sub)



        'XMLファイルの保存
        Dim xmlStorage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication

        If xmlStorage.FileExists(xmlFilePath) = False Then
            Dim xmldoc As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                      <Kanji>
                                          <Pictures RecordDate=<%= recordDate %>>
                                              <PictureName><%= imageFileName %></PictureName>
                                          </Pictures>
                                      </Kanji>
            Using xmlStream As IsolatedStorageFileStream = xmlStorage.CreateFile(xmlFilePath)
            End Using


            If xmlStorage.FileExists(xmlFilePath) = True Then
                Using xmlwriter As StreamWriter = New StreamWriter(xmlStorage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Write), System.Text.Encoding.UTF8)
                    xmlwriter.Flush()
                    xmlwriter.Write(xmldoc.ToString)
                End Using
                Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                              backgroundImage.Source = Nothing
                                                              MessageBox.Show("画像とXMLファイルを保存しました。")
                                                              IchiranShow()
                                                          End Sub)


            End If
        Else
            Dim xmlStream As IsolatedStorageFileStream = xmlStorage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Read)
            Using xmlreader As StreamReader = New StreamReader(xmlStream)

                Dim readXmldoc As String = xmlreader.ReadToEnd
                Dim doc As XElement = XElement.Parse(readXmldoc)
                Dim addXml As XElement = <Pictures RecordDate=<%= recordDate %>>
                                             <PictureName><%= imageFileName %></PictureName>
                                         </Pictures>
                doc.Add(addXml)
                xmlStream.Close()

                If xmlStorage.FileExists(xmlFilePath) = True Then
                    Using xmlwriter As StreamWriter = New StreamWriter(storage.OpenFile(xmlFilePath, FileMode.Open, FileAccess.Write), System.Text.Encoding.UTF8)
                        xmlwriter.Flush()
                        xmlwriter.Write(doc.ToString)
                        'xmlwriter.Close()
                        Deployment.Current.Dispatcher.BeginInvoke(Sub()
                                                                      backgroundImage.Source = Nothing
                                                                      MessageBox.Show("画像とXMLファイルを保存しました。")
                                                                      IchiranShow()
                                                                  End Sub)
                    End Using

                End If
            End Using
        End If
    End Sub


    Private Sub GoShutter(sender As Object, e As EventArgs)
        If myPhotoCamera Is Nothing = False Then
            Try
                imageFileName = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"
                recordDate = DateTime.Now.ToString("yyyy/MM/dd/HH:mm:ss")
                myPhotoCamera.CaptureImage()
            Catch
                Me.Dispatcher.BeginInvoke(Sub() MessageBox.Show("エラーが発生しましたが、データは保存されます。"))
            End Try
        End If
    End Sub

    Private Sub GoIchiran(sender As Object, e As EventArgs)
        InkPresenter1.Children.Remove(myImage)
        NavigationService.Navigate(New Uri("/DataIchiranPage.xaml", UriKind.Relative))
    End Sub

    Private Sub KanjiImageSelect(sender As Object, e As EventArgs)
        NavigationService.Navigate(New Uri("/MainPage.xaml", UriKind.Relative))
    End Sub

    Private Sub IchiranShow()
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim filePath As String = Path.Combine("MultiTouchBehavior", "ImageList.xml")
        If storage.FileExists(filePath) = True Then
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = True
        Else
            TryCast(ApplicationBar.Buttons(1), ApplicationBarIconButton).IsEnabled = False
        End If
    End Sub


    Private Sub GoDelete(sender As Object, e As EventArgs)

        InkPresenter1.Children.Remove(myImage)

    End Sub

End Class

