﻿Option Strict On
Imports System.Xml.Linq
Imports System.IO
Imports System.IO.IsolatedStorage
Public Class KanjiInfo
    Property kanjiImage As String
    Property reading As String
    Property meaning As String
End Class
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub
    Dim myMenuItem1 As New MenuItem
    Dim myMenuItem2 As New MenuItem
    Dim myMenuItem3 As New MenuItem
    Dim myMenuItem4 As New MenuItem
    Dim myMenuItem5 As New MenuItem
    Dim myMenuItem6 As New MenuItem
    Dim myMenuItem7 As New MenuItem

    Dim myContextMenu As New ContextMenu
    Dim xmldoc As XElement
    Dim kanjiImageName As String
    Dim myReading As String
    Dim myMeaning As String

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If storage.DirectoryExists("MultiTouchBehavior") = False Then
            storage.CreateDirectory("MultiTouchBehavior")
        End If

        xmldoc = XElement.Load("kanji.xml")

        Dim myKanjiInfo As New List(Of KanjiInfo)
        For Each result In From c In xmldoc.Descendants("name") Select c
            With myKanjiInfo
                .Add(New KanjiInfo With {.kanjiImage = "Image/" & result.Value, .reading = result.Attribute("reading").Value, .meaning = result.Attribute("meaning").Value})
            End With
        Next
        kanjiListBox.ItemsSource = myKanjiInfo
        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub kanjiListBox_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles kanjiListBox.SelectionChanged
        Try
            kanjiImageName = DirectCast(kanjiListBox.SelectedItem, KanjiInfo).kanjiImage        
            myReading = DirectCast(kanjiListBox.SelectedItem, KanjiInfo).reading
            myMeaning = DirectCast(kanjiListBox.SelectedItem, KanjiInfo).meaning
            Dim menuItemList As New List(Of MenuItem)

            With myMenuItem1
                .Header = "読み"
                .FontSize = 25
                .FontWeight = FontWeights.Bold
                .Foreground = New SolidColorBrush(Colors.Red)
                .Background = New SolidColorBrush(Colors.LightGray)
            End With

            With myMenuItem2
                .Header = myReading
                .FontSize = 28
                .Foreground = New SolidColorBrush(Colors.Blue)
                .Background = New SolidColorBrush(Colors.LightGray)
            End With

            With myMenuItem3
                .Header = "意味"
                .FontSize = 25
                .FontWeight = FontWeights.Bold
                .Foreground = New SolidColorBrush(Colors.Red)
                .Background = New SolidColorBrush(Colors.LightGray)
            End With

            With myMenuItem4
                .Header = New TextBlock With {.Text = myMeaning, .TextWrapping = TextWrapping.Wrap, .Width = 350, .Height = Double.NaN}
                .FontSize = 21
                .Foreground = New SolidColorBrush(Colors.Blue)
                .Background = New SolidColorBrush(Colors.LightGray)
            End With

            With myMenuItem5
                .Header = "この文字を入れて写真を撮る"
                .FontSize = 22
                .FontWeight = FontWeights.Bold
            End With

            With myMenuItem6
                .Header = "データ一覧"
                .FontSize = 22
                .FontWeight = FontWeights.Bold
            End With

            With myMenuItem7
                .Header = "キャンセル"
                .FontSize = 22
                .FontWeight = FontWeights.Bold
            End With

            menuItemList.Add(myMenuItem1)
            menuItemList.Add(myMenuItem2)
            menuItemList.Add(myMenuItem3)
            menuItemList.Add(myMenuItem4)
            menuItemList.Add(myMenuItem5)
            menuItemList.Add(myMenuItem6)
            menuItemList.Add(myMenuItem7)

            myContextMenu.ItemsSource = menuItemList

            Dim isolate As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
            If isolate.FileExists(Path.Combine("MultiTouchBehavior", "ImageList.xml")) = False Then
                myMenuItem6.IsEnabled = False
            Else
                myMenuItem6.IsEnabled = True
            End If


            ContextMenuService.SetContextMenu(kanjiListBox, myContextMenu)
            myContextMenu.IsOpen = True



            AddHandler myMenuItem5.Click, AddressOf myMenuItem_Click
            AddHandler myMenuItem6.Click, AddressOf myMenuItem_Click
            AddHandler myMenuItem7.Click, AddressOf myMenuItem_Click

        Catch
            Exit Sub
        End Try
    End Sub

    Private Sub myMenuItem_Click(sender As Object, e As EventArgs)
        Try
            Dim selectHeader = DirectCast(sender, MenuItem).Header

            Select Case selectHeader.ToString
                Case "この文字を入れて写真を撮る"
                    NavigationService.Navigate(New Uri(String.Format("/CatchPhotoPage.xaml?imagename={0}", kanjiImageName), UriKind.Relative))
                    Exit Select
                Case "データ一覧"
                    NavigationService.Navigate(New Uri("/DataIchiranPage.xaml", UriKind.Relative))
                    Exit Select
                Case "キャンセル"
                    myContextMenu.IsOpen = False
                    kanjiListBox.SelectedIndex = -1
                    Exit Select
                Case Else
                    kanjiListBox.SelectedIndex = -1
                    Exit Select
            End Select
        Catch
            Exit Sub
        End Try

    End Sub

End Class
